unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  fann, MamFann ;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Memo1: TMemo;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Image1: TImage;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    MamFann: TMamFann;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var NeuronNumInLayer:array of Cardinal;
begin
  //TMamFannNX̃CX^X
  if Assigned(MamFann) then
    FreeAndNil(MamFann);

  setlength(NeuronNumInLayer,3);//C[(w)̐
  NeuronNumInLayer[0]:=2;       //͑w̃j[
  NeuronNumInLayer[1]:=3;       //ԑw̃j[
  NeuronNumInLayer[2]:=1;       //o͑w̃j[

  MamFann:=TMamFann.Create(NeuronNumInLayer);

  Button2.Enabled:=true;
  Button3.Enabled:=false;
  Button4.Enabled:=true;

  ShowMessage('ANN̏ݒ芮');
end;
                                                                             //
procedure TForm1.Button2Click(Sender: TObject);
var inputs: array [0..1] of TFann_type;
    outputs: array [0..0] of TFann_type;
    epoch:Integer;   //ÅwK̎{
    i,j: Integer;
    Mse: single; //덷U
begin
  //ÅwK3{
  for epoch:=1 to 30000 do
  begin
    inputs[0]:=0;
    inputs[1]:=0;
    outputs[0]:=trunc(inputs[0]) Xor trunc(inputs[1]);
    MamFann.Train(inputs,outputs);

    inputs[0]:=1;
    inputs[1]:=0;
    outputs[0]:=trunc(inputs[0]) Xor trunc(inputs[1]);
    MamFann.Train(inputs,outputs);

    inputs[0]:=0;
    inputs[1]:=1;
    outputs[0]:=trunc(inputs[0]) Xor trunc(inputs[1]);
    MamFann.Train(inputs,outputs);

    inputs[0]:=1;
    inputs[1]:=1;
    outputs[0]:=trunc(inputs[0]) Xor trunc(inputs[1]);
    MamFann.Train(inputs,outputs);

    if epoch mod 100 = 0 then
    begin
      //덷U̕\
      Mse:=MamFann.GetMSE;
      Label1.Caption:=Format('%.8f',[mse]);
      Application.ProcessMessages;
    end;
  end;

  //wKʂt@Cɕۑ
  //[h[NN.LoadFromFile('abc.net');]ΊwKʂgpł
  MamFann.SaveToFile('a.net');

  //j[lbg[N}̕`
  MamFann.CreateNeuronBmp(Image1.Picture.Bitmap);

  Button2.Enabled:=true;
  Button3.Enabled:=true;
  Button4.Enabled:=true;

  ShowMessage('g[jOI'+#13#10+'wKt@Cۑ');
end;

procedure TForm1.Button3Click(Sender: TObject);
var i,j: integer;
    outputs: array [0..0] of TFann_type;
    inputs : array [0..1] of TFann_type;
begin
  //XORANNs
  Memo1.Lines.Clear;

  inputs[0]:=0;
  inputs[1]:=0;
  MamFann.Run(inputs,outputs);
  Memo1.Lines.Add(
    Format('%1.0f XOR %1.0f = %f',[inputs[0],inputs[1],Outputs[0]])
  );

  inputs[0]:=1;
  inputs[1]:=0;
  MamFann.Run(inputs,outputs);
  Memo1.Lines.Add(
    Format('%1.0f XOR %1.0f = %f',[inputs[0],inputs[1],Outputs[0]])
  );

  inputs[0]:=0;
  inputs[1]:=1;
  MamFann.Run(inputs,outputs);
  Memo1.Lines.Add(
    Format('%1.0f XOR %1.0f = %f',[inputs[0],inputs[1],Outputs[0]])
  );

  inputs[0]:=1;
  inputs[1]:=1;
  MamFann.Run(inputs,outputs);
  Memo1.Lines.Add(
    Format('%1.0f XOR %1.0f = %f',[inputs[0],inputs[1],Outputs[0]])
  );
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if Assigned(MamFann) then
    FreeAndNil(MamFann);
  if not FileExists('a.net') then exit;
  //wKς݃t@C̓ǂݍ
  MamFann:=TMamFann.Create('a.net');

  Button2.Enabled:=true;
  Button3.Enabled:=true;
  Button4.Enabled:=true;

  showmessage('ANNt@C̓ǂݍ݊');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Proportional:=True;
  Image1.Stretch:=True;

  Button2.Enabled:=false;
  Button3.Enabled:=false;
  Button4.Enabled:=true;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(MamFann) then
    FreeAndNil(MamFann);
end;

end.
